#ifndef safe_mode_h
#define safe_mode_h

#include <list/list_type.h>

/*********************************************************************************************************
 *安全模式开启函数:在开启安全模式后,记录代码段区间所有用户已经分配过内存的链表和节点.在结束时,释放记录在案的还未释放的链表和节点.
 *注意:在开启后,只有使用库提供的初始化函数的时候才有效.安全模式打开后,只有调用安全模式结束函数后,才可以重新打开.
 *运用:可以在逻辑较为复杂的代码段使用,预防内存泄漏的情况发生.可以免去繁琐的内存泄漏检查过程.
 *返回: 若成功函数返回0,若失败函数返回-1.
 ********************************************************************************************************/
extern int safeModeForNode(int ifon);

/*安全模式结束时调用,调用后将会释放所有在安全模式区间内用户已经分配过的链表和节点,安全模式将会关闭.*/
extern int releaseAllForNode(void);

#endif /* safe_mode_h */
